using System;
//using org.bouncycastle.io;
using org.bouncycastle.asn1;

namespace org.bouncycastle.asn1.x509
{
	/**
	 * an object for the elements in the X.509 V3 extension block.
	 */
	public class X509Extension
	{
		bool             critical;
		ASN1OctetString      val;

		public X509Extension(
			DERBoolean              critical,
			ASN1OctetString         val)
		{
			this.critical = critical.isTrue();
			this.val = val;
		}

		public X509Extension(
			bool                 critical,
			ASN1OctetString         val)
		{
			this.critical = critical;
			this.val = val;
		}

		public bool isCritical()
		{
			return critical;
		}

		public ASN1OctetString getValue()
		{
			return val;
		}

		public override int GetHashCode()
		{
			if (this.isCritical())
			{
				return this.getValue().GetHashCode();
			}

        
			return ~this.getValue().GetHashCode();
		}

		public override bool Equals(
			Object  o)
		{
			if ((o == null) || !(typeof(X509Extension).IsInstanceOfType(o)))
			{
				return false;
			}

			X509Extension   other = (X509Extension)o;

			return other.getValue().Equals(this.getValue())
				&& (other.isCritical() == this.isCritical());
		}
	}

}