
using System;
using System.IO;
using org.bouncycastle.io;
using org.bouncycastle.crypto;

namespace org.bouncycastle.crypto.io
{
	public class DigestOutputStream : FilterOutputStream
	{
		protected Digest digest;

		public DigestOutputStream(
			Stream    stream,
			Digest          digest) : base(stream)
		{
			this.digest = digest;
		}

		public override  void write(int b)
			//throws IOException
		{
			digest.update((byte)(b));
			outStream.WriteByte((byte)(b));
		}

		public override  void write(
			byte[] b,
			int off,
			int len)
			//throws IOException
		{
			digest.update(b, off, len);
			outStream.Write(b, off, len);
		}

		public Digest getDigest()
		{
			return digest;
		}
	}

}