using System;
using org.bouncycastle.math;

namespace org.bouncycastle.crypto.parameters
{
	public class DHPublicKeyParameters : DHKeyParameters
	{
		private BigInteger      y;

		public DHPublicKeyParameters(
			BigInteger      y,
			DHParameters    parameters) : base(false, parameters)
		{
			this.y = y;
		}   

		public BigInteger getY()
		{
			return y;
		}

		public override bool Equals(Object  obj)
		{
			if (!(typeof(DHPublicKeyParameters).IsInstanceOfType(obj))) return false;
			DHPublicKeyParameters   pKey = (DHPublicKeyParameters)obj;

			if (!pKey.getY().Equals(y))
			{
				return false;
			}

			return base.Equals(obj);
		}
		public override int GetHashCode()
		{
			return base.GetHashCode();
		}

	}

}